library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity tb_compito is
end tb_compito;

architecture tbc of tb_compito is
component compito is
	port ( din: in std_logic_vector(15 downto 0);
	clk, rst, esegui: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic );
end	component;

signal din, ris: std_logic_vector( 15 downto 0);
signal clk, rst, esegui, fine: std_logic;

begin
	du: compito port map (din,clk,rst,esegui,ris,fine);
	
	rst <= '1' after 1 ns, '0' after 11 ns;
	
	process
	begin
		clk <= '0';
		wait for 10 ns;
		clk <= '1';
		wait for 10 ns;
	end process;
	
	process 
	begin
	 esegui <= '0';
	 wait for 21 ns;
	 esegui <= '1';
	 wait until fine = '1';
	 
	end process;
	
	process
	begin
	  	--shl
		wait for 41 ns;
	  din <= conv_std_logic_vector(1,16);
	  wait for 20 ns;
	  din <= conv_std_logic_vector(14,16);
	  wait for 20 ns;
	  din <=conv_std_logic_vector(2,16);
	  wait until fine='1';	
	  --or
	  wait for 41 ns;
	  din <= conv_std_logic_vector(0,16);
	  wait for 20 ns;
	  din <= conv_std_logic_vector(10,16);
	  wait for 20 ns;
	  din <=conv_std_logic_vector(8,16);
	  wait until fine='1';	
	  
	  -- cnt1
	  wait for 41 ns;
	  din <= conv_std_logic_vector(2,16);
	  wait for 20 ns;
	  din <= conv_std_logic_vector(38,16);
	  wait until fine='1';
	  
	  --par
	  wait for 41 ns;
	  din <= conv_std_logic_vector(3,16);
	  wait for 20 ns;
	  din <= conv_std_logic_vector(14,16);
	  wait until fine='1';
   end process;
end tbc;

	